<?php
/* Autor...:  */
/* Esquema.: ALM_AlmacenGrupo.xml */
/* Generado: 2020-08-18 04:21:23 */

/* Metodos de acceso a los campos de la tabla ALM_AlmacenGrupo */
abstract class BaseALM_AlmacenGrupoBN
{
    /* Campos de la tabla */
    private $s_IdAlmacenGrupo;    // IdAlmacenGrupo: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdAlmacenGrupo */
    public function setIdAlmacenGrupo( $s_IdAlmacenGrupo )
    {
        $this->s_IdAlmacenGrupo = $s_IdAlmacenGrupo;
    }

    /* Obtiene el valor del campo IdAlmacenGrupo */
    public function getIdAlmacenGrupo()
    {
        return $this->s_IdAlmacenGrupo;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdAlmacenGrupo' => $this->getIdAlmacenGrupo(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'Descripcion' => $this->getDescripcion(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_AlmacenGrupoBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_AlmacenGrupoRs )
    {
        $o_ALM_AlmacenGrupoBN = new ALM_AlmacenGrupoBN();
        $o_ALM_AlmacenGrupoBN->setIdAlmacenGrupo( $o_ALM_AlmacenGrupoRs[ "IdAlmacenGrupo" ] );
        $o_ALM_AlmacenGrupoBN->setIdCompania( ( integer ) $o_ALM_AlmacenGrupoRs[ "IdCompania" ] );
        $o_ALM_AlmacenGrupoBN->setIdSucursal( ( integer ) $o_ALM_AlmacenGrupoRs[ "IdSucursal" ] );
        $o_ALM_AlmacenGrupoBN->setDescripcion( $o_ALM_AlmacenGrupoRs[ "Descripcion" ] );
        $o_ALM_AlmacenGrupoBN->setEstado( $o_ALM_AlmacenGrupoRs[ "Estado" ] );
        $o_ALM_AlmacenGrupoBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_AlmacenGrupoRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_AlmacenGrupoBN->setUsuarioCreacion( $o_ALM_AlmacenGrupoRs[ "UsuarioCreacion" ] );
        $o_ALM_AlmacenGrupoBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_AlmacenGrupoRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_AlmacenGrupoBN->setUsuarioModificacion( $o_ALM_AlmacenGrupoRs[ "UsuarioModificacion" ] );
        return $o_ALM_AlmacenGrupoBN;
    }
}
?>